<template>
  <b-container fluid class="p-3">
    <p class="text-bold">Edit an Employee</p>
    <employee-form
      :employee="employee"
      :editable="true"
      @submit="onSubmit"
      @debug="store.employee.debug"
    />
  </b-container>
</template>

<script lang="ts">
import { Vue, Component } from 'vue-property-decorator'
import { provide, consume } from 'provide-consume-decorator'
import { getModule } from 'vuex-module-decorators'
import { path } from 'ramda'
import Form from '@/components/Employee/EmployeeForm.vue'
import { CreateEmployee, EditEmployeePayload } from '@/types/employee'
import EmployeeStore from '@/store/modules/employee'

interface Store {
  employee: EmployeeStore
}

@Component({
  components: { 'employee-form': Form },
  head() {
    return {
      title: `Edit an Employee`,
      meta: [
        {
          hid: 'description',
          name: 'description',
          content: 'You can edit a new employee'
        }
      ]
    }
  }
})
@provide({
  store(): Store {
    return {
      employee: getModule(EmployeeStore, this.$store)
    }
  }
})
export default class EmployeeEdit extends Vue {
  @consume('store') store!: Store

  get employee() {
    console.log('Edit', this.store.employee.employee)
    return this.store.employee.employee
  }

  created() {
    if (!path(['$route', 'params', 'id'], this)) {
      this.$router.replace({ name: 'employee' })
    } else {
      this.store.employee.getEmployee(this.$route.params.id)
      console.log('Edit created', this.store.employee.employee)
    }
  }

  onSubmit(data: CreateEmployee) {
    this.store.employee.editEmployee({
      id: this.$route.params.id,
      data
    } as EditEmployeePayload)
  }
}
</script>
